@echo off
rem Always you must be carefull for spaces and special characters in path name

setlocal enabledelayedexpansion
set GDBNAME=rl78-elf-gdb
set GDBSERVERNAME=e2-server-gdb
set SUPPORT_TARGET_LOC=%~dp1
set SUPPORT_AREA=%SUPPORT_TARGET_LOC:\DebugComp\RL78\=%
set PYTHONHOME=%~2
call :tool_path_setup_for_gdbserver
call :parse_launch_config_file_for_gdbserver %3 LCFG_ARGS
for /f "tokens=1* delims=;" %%I in ("%*") do set USER_ARGS=%%J

cd /d "%SUPPORT_TARGET_LOC%"
%GDBSERVERNAME%.exe %LCFG_ARGS% %USER_ARGS%
exit /b %ERRORLEVEL%

:parse_launch_config_file_for_gdbserver
set KEY=com.renesas.cdt.core.serverParam
set VALUE=
set LAUNCH_CONFIG_FILE=%~1
rem Replace path separators from `/` to `\` to avoid troubles
set LAUNCH_CONFIG_FILE=%LAUNCH_CONFIG_FILE:/=\%
if "%LAUNCH_CONFIG_FILE%" == "" (
    echo Error: No launch file is specified. Please check the 'launch.json' file.>&2
    call :error -1
)
if not exist "%LAUNCH_CONFIG_FILE%" (
    echo Error: The following launch file is not found. Please check the 'launch.json' file.^
 "%LAUNCH_CONFIG_FILE%">&2
    call :error -1
)
for /f "usebackq tokens=3,4* delims== " %%I in ("%LAUNCH_CONFIG_FILE%") do (
    if "%%~I" == "%KEY%" (
        set T=%%K
        rem Remove `"` and `"/>`
        set VALUE=!T:~1,-3!
        goto :parse_launch_config_file_for_gdbserver_search_key_break
    )
)
:parse_launch_config_file_for_gdbserver_search_key_break
if "%VALUE%" == "" (
    echo Error: The following launch file is not supported. Please contact to 'japan.renesasrulz.com/cafe_rene/f/forum21'.^
 "%LAUNCH_CONFIG_FILE%">&2
    call :error -1
)
set %2=%VALUE%
goto :EOF

:tool_path_setup_for_gdbserver
if "%SUPPORT_AREA%" == "" (
    echo Error: The following path is not defined. Please check the 'CppProperties.json' file.^
 "SUPPORT_AREA=">&2
    call :error -1
)
if not exist "%SUPPORT_AREA%" (
    echo Error: The following folder is not found. Please check the 'CppProperties.json' file.^
 "%SUPPORT_AREA%"^
 ^("SUPPORT_AREA=" defines the path.^)>&2
    call :error -1
)
if not exist "%SUPPORT_TARGET_LOC%\%GDBSERVERNAME%.exe" (
    echo Error: The following program is not found. Please check e2 studio installation.^
 "%SUPPORT_TARGET_LOC%\%GDBSERVERNAME%.exe">&2
    call :error -1
)
rem The following checks will be done later for gdb but do the checks here too.
if not exist "%SUPPORT_TARGET_LOC%\%GDBNAME%.exe" (
    echo Error: The following program is not found. Please check e2 studio installation.^
 "%SUPPORT_TARGET_LOC%\%GDBNAME%.exe">&2
    call :error -1
)
if "%PYTHONHOME%" == "" (
    echo Error: The following path is not defined. Please check the 'CppProperties.json' file.^
 "PYTHONHOME=">&2
    call :error -1
)
if not exist "%PYTHONHOME%" (
    echo Error: The following folder is not found. Please check the 'CppProperties.json' file.^
 "%PYTHONHOME%"^
 ^("PYTHONHOME=" defines the path.^)>&2
    call :error -1
)
goto :EOF

:error
rem Tell VSCode that launching gdbserver is failed.
echo GDB: ...
exit %1
